#include "iodefine.h"
#include "ivects.h"
#include "timer.h"

volatile unsigned long timer_ms;

static void __attribute__((interrupt))
mtu0_handler ()
{
  timer_ms ++;
}

void
timer_init ()
{
  timer_ms = 42;

  /* Timer */
  _vectors[VECT(MTU0,TGIA0)] = mtu0_handler;
  IEN(MTU0,TGIA0) = 1;
  IPR(MTU0,TGIA0) = 5;

  MTU0.TCR.BYTE = 0x21; /* TGRA, PCLK/4 = 12 MHz */
  MTU0.TIER.BYTE = 0x01; /* interrupt on TGRA */
  MTU0.TGRA = 12000; /* should be 1 mS */
  MTUA.TSTR.BYTE |= 0x01; /* start timer */

  MTU1.TCR.BYTE = 0x02; /* free running, PCLK/16 = 3 MHz */
  MTU1.TIER.BYTE = 0x00; /* no interrupts */
  MTUA.TSTR.BYTE |= 0x02; /* start timer */
}

void
wait_ms (long ms)
{
  unsigned long now = timer_ms;
  while ((long)(timer_ms - now) < ms)
    ;
}

#define timer_us MTU1.TCNT

static unsigned short now_us;

void
wait_us (long us)
{
  now_us = timer_us;
  us *= 3;
  while ((short)(timer_us - now_us) < us)
    ;
}

void
wait_us_more (long us)
{
  us *= 3;
  while ((short)(timer_us - now_us) < us)
    ;
}
